%define name firebird
%define version 1.5.2.4731
%define release 0.3mdk

%define major 1
%define libname %mklibname %{name} %major
%define libnamedev %mklibname %{name} %major -d

%define _target_cpu	i586
%define	fbroot		%{_datadir}/%{name}

Name:           %name
Version:        %version
Release:        %release
Summary:        Firebird SQL Database, fork of InterBase

Group:          Databases
License:        IPL
URL:            http://firebird.sourceforge.net/
Source0:        http://aleron.dl.sourceforge.net/sourceforge/firebird/firebird-%{version}.tar.bz2
Patch0:		firebird-install.patch.bz2
Patch1:		firebird-xinetd.patch.bz2
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:  byacc, autoconf, automake, libtool
Requires:    	%{name}-server-classic = %{version}
Requires:	%{name}-client-embedded = %{version}
Requires:	grep, sed

%description
This is the Firebird SQL Database shared files. 

# 
# Development headers and static libraries
#
%package        devel
Summary:        Development Libraries for Firebird SQL Database
Group:          Development/Databases
Requires:       %{name} = %{version}

%description    devel
Development libraries for firebird.

#
# Standard client programs
#


#
# Client programs
#
%package		client-embedded
Summary:		Client programs for Firebird SQL Database
Group:          	Databases
Requires:		%{name}-server-classic = %{version}
Requires:		%{name}-lib = %{version}
Provides:		%{name}-client

%description	client-embedded
Client access tools for firebird.

#
# Multi-threaded, independant client libraries
#
%package -n %libname
Summary: Multi-threaded, non-local client libraries for Firebird SQL Database
Group: System/Libraries
Provides:		%{name}-lib = %{version}

%description -n %libname
Multi-threaded, non-local client libraries for Firebird SQL Database
#
# Super server programs
#


#
# Classic server programs
#
%package		server-classic
Summary:		Classic (xinetd) server for Firebird SQL Database
Group:          	Databases
Provides:		firebird-server
Requires:		xinetd, %{name}
Requires(pre): 		/usr/sbin/useradd,/usr/sbin/groupadd
Requires(postun): 	/usr/sbin/userdel,/usr/sbin/groupdel

%description 	server-classic
This is the classic (xinetd) server for the Firebird SQL Database.
It can also be used as an embedded server, when paired with the 
client-embedded package.

It does not include any client access tools, nor does it include the 
multi-threaded client library. It includes a xinetd.d script that is 
disabled by default.



%prep
%setup -q
%patch0

# -----------------------------------------------------------------------------

%build

%configure
	
make 

# -----------------------------------------------------------------------------

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make prefix=$RPM_BUILD_ROOT%{fbroot} install
    	
# Move binaries libraries to better locations
install -d $RPM_BUILD_ROOT%{_prefix}

# Install lib
mv $RPM_BUILD_ROOT%{fbroot}/lib $RPM_BUILD_ROOT%{_libdir}

# Install includes
mv $RPM_BUILD_ROOT%{fbroot}/include $RPM_BUILD_ROOT%{_includedir}

# Build /etc/firebird
install -d $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/
mv $RPM_BUILD_ROOT%{fbroot}/*.conf $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
install -d $RPM_BUILD_ROOT%{_localstatedir}/%{name}
mv $RPM_BUILD_ROOT%{fbroot}/*.fdb $RPM_BUILD_ROOT%{_localstatedir}/%{name}

# set the root directory in firebird.conf
ESCAPED=`echo %{fbroot} | sed -e "s/\//\\\\\\\\\//g"`
sed -i -e "s/#RootDirectory =/RootDirectory = $ESCAPED/" \
	$RPM_BUILD_ROOT%{_sysconfdir}/%{name}/firebird.conf

# Create wrapper links for client library
#ln -s libfbembed.so.1 $RPM_BUILD_ROOT%{_libdir}/libfbclient.so.1
ln -s libfbclient.so.1 $RPM_BUILD_ROOT%{_libdir}/libgds.so


# Link in firebird.conf, security.fdb and firebird.log into the root
# directory locations they're expected in.
ln -s %{_sysconfdir}/%{name}/firebird.conf $RPM_BUILD_ROOT%{_prefix}/firebird.conf
ln -s %{_sysconfdir}/%{name}/aliases.conf $RPM_BUILD_ROOT%{fbroot}/aliases.conf
ln -s %{_localstatedir}/%{name}/security.fdb $RPM_BUILD_ROOT%{fbroot}/security.fdb
ln -s %{_localstatedir}/log/firebird.log $RPM_BUILD_ROOT%{fbroot}/firebird.log

# Link in the lock manager
install -d $RPM_BUILD_ROOT%{_datadir}/%{name}/bin

# Install the xinetd script
install -d $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d
mv $RPM_BUILD_ROOT%{_datadir}/%{name}/misc/firebird.xinetd $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d/%{name}

# link isql to /usr/bin/fbsql
install -d $RPM_BUILD_ROOT%{_bindir}
ln -s %{fbroot}/bin/isql $RPM_BUILD_ROOT%{_bindir}/fbsql 

rm -f $RPM_BUILD_ROOT%{_infodir}/dir
find $RPM_BUILD_ROOT -type f -name "*.la" -exec rm -f {} ';'

# -----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------
# lib scripts
# -----------------------------------------------------------------------------

%post -n %libname -p /sbin/ldconfig

%postun -n %libname -p /sbin/ldconfig
# -----------------------------------------------------------------------------
# client-embedded scripts
# -----------------------------------------------------------------------------
%post client-embedded
# Install the isql symlink if theres no isql binary present
if [ ! -f %{_bindir}/isql ]; then ln -s fbsql %{_bindir}/isql; fi

%postun client-embedded
# Remove isql ONLY if it's a symlink
if [ -h %{_bindir}/isql ]; then /bin/rm %{_bindir}/isql; fi

# -----------------------------------------------------------------------------
# server-classic scripts
# -----------------------------------------------------------------------------
%pre server-classic
# Create the firebird group if it doesn't exist
grep -q %{name} /etc/group || /usr/sbin/groupadd -r %{name} || true
grep -q %{name} /etc/passwd || /usr/sbin/useradd -g %{name} -s /sbin/nologin -r %{name} || true

%post server-classic -p /sbin/ldconfig

# Add gds_db to /etc/services if needed
FileName=/etc/services
newLine="gds_db          3050/tcp  # Firebird SQL Database Remote Protocol"
oldLine=`grep "^gds_db" $FileName`
if [ -z "$oldLine" ]; then
	echo "" >> $FileName
	echo $newLine >> $FileName
	echo "" >> $FileName
fi

touch %{_localstatedir}/log/firebird.log
chown %{name}:%{name} %{_localstatedir}/log/firebird.log
/sbin/service xinetd reload

%postun server-classic -p /sbin/ldconfig
/sbin/service xinetd reload

# -----------------------------------------------------------------------------

%files 
%defattr(0644,root,root,-)
%doc %{fbroot}/README
%doc %{fbroot}/WhatsNew
%doc %{fbroot}/doc/
%doc %{fbroot}/examples/

%files devel
%defattr(-,root,root,-)
%{_includedir}/*

%files client-embedded
%defattr(-,root,root,-)
%attr(0750, %{name}, %{name}) %{_bindir}/*

%files -n %libname
%defattr(-,root,root,-)
%{_libdir}/libfbclient.*
%{_libdir}/libgds.so

%files server-classic
%defattr(0644,root,root,-)
%{_prefix}/firebird.conf
%dir %{fbroot}/bin
%attr(0755, %{name}, %{name}) %{fbroot}/bin/*
%{fbroot}/firebird.msg
%{fbroot}/firebird.log
%{fbroot}/security.fdb
%{fbroot}/aliases.conf
%{_libdir}/libfbembed.so*
%{_libdir}/libib_util.so*
%{_datadir}/%{name}/help
%{_datadir}/%{name}/intl
%dir %{fbroot}/UDF
%{fbroot}/UDF/*
%dir %attr(0775, %{name}, %{name}) %{fbroot}
%attr(0775, %{name}, %{name}) %{_localstatedir}/%{name}
%config(noreplace) %attr(0660, %{name}, %{name}) %{_localstatedir}/%{name}/security.fdb
%config %{_sysconfdir}/%{name}/*
%config %{_sysconfdir}/xinetd.d/%{name}

# -----------------------------------------------------------------------------

%changelog
* Mon Jul 25 2005 Stew Benedict <sbenedict@mandriva.com> 1.5.2.4731-0.3mdk
- fix provides in lib package

* Fri Jan 28 2005 Lenny Cartier <lenny@mandrakesoft.com> 1.5.2.4731-0.2mdk
- add deps
- little spec cleaning

* Wed Jan 12 2005 Lenny Cartier <lenny@mandrakesoft.com> 1.5.2.4731-0.1mdk
- from Philippe Makowski <makowski@firebird-fr.eu.org> : 
	- adapted to Mandrake
	- updated from the CVS tree
- libification
- bzip2 patches
- use configure macros
- requires on versions not on releases

* Thu Aug 17 2004 Erik S. LaBianca <erik@ilsw.com> - 1.5.1.4481-0.fdr.1
- updated to 1.5.1 official source release
- minimized install patch intrusiveness, move files in .spec file instead
- don't try to remove the user/group on install, just leave the mess

* Thu Feb 04 2004 Erik S. LaBianca <erik@ilsw.com> - 1.5.0.4280-postRC8.1
- updated to CVS code
- remove lock files from post/postun
- set target arch to match prefix.linux settings
- add dependencies to firebird RPM

* Wed Feb 03 2004 Erik S. LaBianca <erik@ilsw.com> - 1.5.0.4201-1
- updated to RC8 code
- added gds_db service entry to /etc/services if necessary in post
- fix isql link

* Thu Nov 13 2003 Erik S. LaBianca <erik@ilsw.com> - 1.5.0.4027-5
- added -s /sbin/nologin to useradd command

* Thu Nov 13 2003 Erik S. LaBianca <erik@ilsw.com> - 1.5.0.4027-4
- fixed postinstall scripts, changed && to ||

* Thu Nov 13 2003 Erik S. LaBianca <erik@ilsw.com> - 1.5.0.4027-3
- fixed postinstall scripts as per suggestion by Brad Pepers

* Wed Nov 12 2003 Erik S. LaBianca <erik@ilsw.com> - 1.5.0.4027-2
- fixed /usr/share/firebird/bin/fb_lock_mgr symlink
- fixed??? postinstall scripts to add user and group

* Tue Nov 04 2003 Erik S. LaBianca <erik@ilsw.com> - 1.5.0.3780-4
- /sbin/service reload xinetd after in %post and %postun to activate /etc/xinetd.d/firebird
- updated to latest cvs snapshot
- changed xinetd file to disable=no only_from=127.0.0.1 to retain security but allow local network access
- renamed isql to fbsql and create a symlink to isql (if there isn't one), allowing concurrent unixODBC install
- moved logfile to /var/log/firebird.log, create a blank logfile after post so symlink resolves
- fixed the %postun script to test for additional users in the firebird group without errors
- Added /usr/firebird.conf to server-classic
- tagged /var/firebird/security.fdb as a config file so it doesn't get nuked

* Mon Nov 03 2003 Erik S. LaBianca <erik@ilsw.com> - 1.5.0.3780-1
- Initial RPM release.
